--------------------------------------------------------------------------------
----------------------------------   Home Stone --------------------------------
--------------------------------- (HearthStone 2) ------------------------------
--------------------------------------------------------------------------------
-- 
--------------------------------------------------------------------------------
Global( "wtMainPanel", mainForm:GetChildChecked( "MainPanel", false ))
Global( "wtHomeStoneText",wtMainPanel:GetChildChecked( "HomeStoneText", false ))
Global( "wtHomeStoneTextMyr",wtMainPanel:GetChildChecked( "HomeStoneTextMyr", false ))
Global( "wtHomeStoneTextOb",wtMainPanel:GetChildChecked( "HomeStoneTextOb", false ))
Global( "wtHomeStoneTextQuests",wtMainPanel:GetChildChecked( "HomeStoneTextQuests", false ))
Global( "wtHomeStoneTextDQuests",wtMainPanel:GetChildChecked( "HomeStoneTextDQuests", false ))
Global( "wtHomeStoneTextBag",wtMainPanel:GetChildChecked( "HomeStoneTextBag", false ))
Global( "wtHomeStoneTextMon",wtMainPanel:GetChildChecked( "HomeStoneTextMon", false ))
Global( "HStoneInit", userMods.GetGlobalConfigSection("HStoneInit"))
Global( "QuestsNow", 0 )
Global( "QuestsNowTMP", 0 )
Global( "QuestsAll", 0 )
Global( "DQuestsNow", 0 )
Global( "DQuestsAll", 0 )
--------------------------------------------------------------------------------
-- 
--------------------------------------------------------------------------------
--  AddonManager
function OnAMMemUsageRequest( params )
	userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", { sender = common.GetAddonName(), memUsage = gcinfo() } )
end

function OnInfo( params )
	if params.target == common.GetAddonName() then
		userMods.SendEvent( "SCRIPT_ADDON_INFO_RESPONSE", {
		sender = params.target,
		desc = "Shows holly charms, myrrh, free quests and daily quests, bag freespace, money, cooldown of HeathStone."
		} )
	end
end
--  DnD
function OnToggleDnD( params )
	if params.target == common.GetAddonName() then
		DnD:Enable( wtMainPanel, params.state )
	end
end
--  
function GetTableSize( params ) 		--  
	if not params then return 0 end
	return params[0] and table.getn(params)+1 or table.getn(params)
end
function CopyTable ( sourceTable ) 		--  
	local targetTable = {}
	for key, value in sourceTable do
   	targetTable[ key ] = value
	end
	return targetTable
end
-- 
function OnUseHomeStone( params ) 		--  -    
	avatar.UseHearthStone()
end
function OnCDStart ( params ) 			--  
	local cooldown = avatar.GetHearthStoneCooldown()
	local tmp = math.ceil(cooldown.remainingMs / 1000)
	if tmp >59 then
		tmp = math.ceil(tmp / 60)
	end
	wtHomeStoneText:SetVal( "value", common.FormatInt( tmp , "%d" ) )
end
function OnCooldownStarted( params ) 	--     
	common.RegisterEventHandler( OnCDStart, "EVENT_SECOND_TIMER" )
	wtHomeStoneText:Show( true )
end
function OnCooldownFinished( params ) 	--    
	common.UnRegisterEventHandler( OnCDStart, "EVENT_SECOND_TIMER" )
	wtHomeStoneText:Show( false )
end

function OnMoney( params ) 				--  
	local money = avatar.GetMoney()
	local gold = math.floor(money / 10000)
	local silver = math.floor(money / 100) - (gold*100)
	local copper = money - (gold*10000) - (silver*100)
	if money then
		wtHomeStoneTextMon:SetVal( "gold", common.FormatInt( gold , "%dK5" ) )
		wtHomeStoneTextMon:SetVal( "silver", common.FormatInt( silver , "%dK5" ) )
		--wtHomeStoneTextMon:SetVal( "copper", common.FormatInt( copper , "%dK5" ) )
	else
		wtHomeStoneTextMon:SetVal( "gold", common.FormatInt( 0 , "%dK5" ) )
		wtHomeStoneTextMon:SetVal( "silver", common.FormatInt( 0 , "%dK5" ) )
		--wtHomeStoneTextMon:SetVal( "copper", common.FormatInt( 0 , "%dK5" ) )
	end
end

function OnBag( params ) 				--    
	local countBag = avatar.InventoryGetBaseBagSlotCount()
	local index1 = countBag-1
	local index2 = index1+countBag
	local index3 = index2+countBag
	local count1 = 0
	local count2 = 0
	local count3 = 0
	for i = 0, index1 do
		local id = avatar.GetInventoryItemId( i )
		if id then count1 = count1 + 1 end
	end
	for i = countBag, index2 do
		local id = avatar.GetInventoryItemId( i )
		if id then count2 = count2 + 1 end
	end
	for i = countBag*2, index3 do
		local id = avatar.GetInventoryItemId( i )
		if id then count3 = count3 + 1 end
	end
	count1 = countBag - count1
	count2 = countBag - count2
	count3 = countBag - count3
	--Bag = count1.."/"..count2.."/"..count3
	wtHomeStoneTextBag:SetVal( "bag1", common.FormatInt( count1 , "%dK5" ) )
	wtHomeStoneTextBag:SetVal( "bag2", common.FormatInt( count2 , "%dK5" ) )
	wtHomeStoneTextBag:SetVal( "bag3", common.FormatInt( count3 , "%dK5" ) )
end

function OnQuests( params ) 			--  
	QuestsNowTMP = avatar.GetQuestBook()
	QuestsNow = GetTableSize( QuestsNowTMP )
	QuestsAll = avatar.GetQuestsLimit()
	wtHomeStoneTextQuests:SetVal( "quests1", common.FormatInt( QuestsNow , "%dK5" ) )
	wtHomeStoneTextQuests:SetVal( "quests2", common.FormatInt( QuestsAll , "%dK5" ) )
end

function OnDQuests( params ) 			--   
	local dailyInfo = avatar.GetQuestBookDaily()
	DQuestsNow = dailyInfo.count
	DQuestsAll = dailyInfo.limit
	wtHomeStoneTextDQuests:SetVal( "dquests1", common.FormatInt( DQuestsNow , "%dK5" ) )
	wtHomeStoneTextDQuests:SetVal( "dquests2", common.FormatInt( DQuestsAll , "%dK5" ) )
end

function OnQuestsChanged( params ) 		--   
	OnQuests()
	OnDQuests()
end

function SlashCommand(params) 			-- 
	--       
	if userMods.FromWString(params.text) == "/hsreset" then
		HStoneInit = {}
		HStoneInit["ShowFull"] = true
		userMods.SetGlobalConfigSection("HStoneInit", HStoneInit)
		OnFormResize()
	--   
	elseif userMods.FromWString(params.text) == "/hsmax" then
		HStoneInit["ShowFull"] = true
		userMods.SetGlobalConfigSection("HStoneInit", HStoneInit)
		OnFormResize()
	--  
	elseif userMods.FromWString(params.text) == "/hsmin" then
		HStoneInit["ShowFull"] = false
		userMods.SetGlobalConfigSection("HStoneInit", HStoneInit)
		OnFormResize()
	end
end

function OnEventTimer( params ) 		--  
	if avatar.IsExist() then
		-- 
		local MyrId = avatar.GetCurrencyId( "myrrh" )
		if MyrId then
			local info = avatar.GetCurrencyInfo( MyrId )
				if info then
					local currentValue = info.value
					wtHomeStoneTextMyr:SetVal( "myr", common.FormatInt( currentValue, "%dK5" ) )
				end
		else
			--  
			wtHomeStoneTextMyr:SetVal( "myr", common.FormatInt( 0 , "%dK5" ) )
		end
		-- 
		local ObId = unit.GetEquipmentItemId(avatar.GetId(), DRESS_SLOT_DEATHINSURANCE, ITEM_CONT_EQUIPMENT)
		if ObId then
			local ObValue = avatar.GetItemInfo(ObId).stackCount
			if ObValue then
				wtHomeStoneTextOb:SetVal( "ob", common.FormatInt( ObValue, "%dK5" ) )
			end
		else
			--  
			wtHomeStoneTextOb:SetVal( "ob", common.FormatInt( 0 , "%dK5" ) )
		end
	end
end

function OnFormResize() 				--  
	local placement = wtMainPanel:GetPlacementPlain()
	local widgetPlacement = CopyTable(placement)
	--  
	if HStoneInit["ShowFull"] then
		placement.sizeX = 140
		wtMainPanel:SetPlacementPlain( placement )
	elseif not HStoneInit["ShowFull"] then
		placement.sizeX = 44
		wtMainPanel:SetPlacementPlain( placement )
	end
end
function OnAvatarCreated() 				--  
	OnFormResize()
	common.RegisterEventHandler( OnEventTimer, "EVENT_SECOND_TIMER" )
	OnBag()
	OnMoney()
	OnQuests()
	OnDQuests()
end
-- 
function Init()
	DnD:Init( 396, wtMainPanel, wtMainPanel, true, true, { -8,-8,-8,-8 } )
	--  
	if not HStoneInit then
		HStoneInit = {}
		HStoneInit["ShowFull"] = true
	end
	userMods.SetGlobalConfigSection("HStoneInit", HStoneInit)
	OnFormResize()
	if avatar.IsExist() then OnAvatarCreated() end
	--   
		common.RegisterEventHandler(SlashCommand, "EVENT_UNKNOWN_SLASH_COMMAND")
	--  
		common.RegisterEventHandler(OnAvatarCreated,"EVENT_AVATAR_CREATED")

	--  "AddonManager"
		common.RegisterEventHandler( OnAMMemUsageRequest, "U_EVENT_ADDON_MEM_USAGE_REQUEST" )
		common.RegisterEventHandler( OnInfo, "SCRIPT_ADDON_INFO_REQUEST" )

	-- 
		common.RegisterReactionHandler( OnUseHomeStone, "UseHomeStone" )
		--common.RegisterReactionHandler( OnUseHomeStone, "UseHomeStone" )
--SCRIPT_HEARTHSTONE_PRESSED

	--      
		common.RegisterEventHandler( OnCooldownStarted, "EVENT_HEARTHSTONE_COOLDOWN_STARTED" )
		common.RegisterEventHandler( OnCooldownFinished, "EVENT_HEARTHSTONE_COOLDOWN_FINISHED" )
		common.RegisterEventHandler( OnMoney, "EVENT_AVATAR_MONEY_CHANGED" )
		common.RegisterEventHandler( OnBag, "EVENT_INVENTORY_CHANGED" )
		common.RegisterEventHandler( OnQuests, "EVENT_QUEST_BOOK_CHANGED" )
		common.RegisterEventHandler( OnDQuests, "EVENT_QUEST_BOOK_DAILY_CHANGED" )
		common.RegisterEventHandler( OnQuestsChanged,"EVENT_QUEST_BOOK_LIMITS_CHANGED")
		common.RegisterEventHandler( OnToggleDnD, "U_EVENT_TOGGLE_DND" )

end

--------------------------------------------------------------------------------
Init()
--------------------------------------------------------------------------------
